<template>
	<v-container>
		<p class="display-1 text-center">Información de {{name}}</p>
		<p class="font-weight-bold">Folio: {{folio}}</p>
		<StudentPersonalData class="mb-5" />
		<StudentAddressData class="mb-5" />
		<StudentScholarData />
		<v-row class="mt-3" justify="space-around">
			<v-col cols="12" sm="2">
				<v-btn
					dark
					block
					color="orange"
					:to="{name:'DocumentsStudent',params:{student:$route.params.student,typeScholarshipAdmin:lastScholarship}}"
				>Documentos</v-btn>
			</v-col>
			<v-col cols="12" sm="2">
				<v-btn dark block color="blue" :to="{name:'Requests'}">Regresar</v-btn>
			</v-col>
		</v-row>
		<Navigation />
	</v-container>
</template>

<script>
import Navigation from "@/components/Navigation";
import EventBus from "../../bus";
import gql from "graphql-tag";
import { mapMutations } from "vuex";
import StudentPersonalData from "@/components/admin/StudentPersonalData";
import StudentAddressData from "@/components/admin/StudentAddressData";
import StudentScholarData from "@/components/admin/StudentScholarData";

export default {
	name: "InfoStudent",
	components: {
		Navigation,
		StudentPersonalData,
		StudentAddressData,
		StudentScholarData
	},
	data: () => ({
		name: "",
		folio: "",
		lastScholarship: "a"
	}),
	methods: {
		...mapMutations(["saveUserData"]),
		// Obtiene toda la informacion del estudiante
		async getDataStudent() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								serial
								personalData {
									name
									fstSurname
									sndSurname
									age
									gender
									ethnicGroup
								}
								addressData {
									state
									city
									neighborhood
									street
									number
									postalCode
									mobilePhoneNumber
									housePhoneNumber
								}
								scholarData {
									institute
									career
									semester
									schoolGrade
								}
								scholarshipRecord {
									scholarship
								}
							}
						}
					`,
					variables: {
						curp: this.$route.params.student
					}
				});

				this.name = `${data.findStudent.personalData.name} ${data.findStudent.personalData.fstSurname} ${data.findStudent.personalData.sndSurname}`;
				this.folio = data.findStudent.serial;
				this.route(data.findStudent.scholarshipRecord[0].scholarship);
				EventBus.$emit(
					"sendPersonalData",
					data.findStudent.personalData
				);
				EventBus.$emit("sendAddressData", data.findStudent.addressData);
				EventBus.$emit("sendScholarData", data.findStudent.scholarData);
			} catch (error) {}
		},
		// cambia el nombre de la beca para la ruta
		route(scholarship) {
			switch (scholarship) {
				case "Talento especial":
					this.lastScholarship = "talento-especial";
					break;
				case "Excelencia académica":
					this.lastScholarship = "excelencia-académica";
					break;
				case "Mejora académica":
					this.lastScholarship = "mejora-académica";
					break;
				case "Labsol":
					this.lastScholarship = "labsol";
					break;
			}
		}
	},
	created() {
		this.saveUserData();
		this.getDataStudent();
	}
};
</script>